/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is 
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   David Epstein <depstein@netscape.com> 
 *
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// File Overview....
// 
// Header file for nsiWebProgress interface test cases

#if !defined(AFX_NSIWEBPROG_H__8024AB8F_6DB3_11D6_9BA5_00C04FA02BE6__INCLUDED_)
#define AFX_NSIWEBPROG_H__8024AB8F_6DB3_11D6_9BA5_00C04FA02BE6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// nsiWebProg.h : header file
//

#include "BrowserView.h"
#include "BrowserImpl.h"
#include "StdAfx.h"
#include "Tests.h"

/////////////////////////////////////////////////////////////////////////////
// CnsiWebProg window

class CBrowserImpl;

class CnsiWebProg
{
public:
	// Construction
	CnsiWebProg(nsIWebBrowser *mWebBrowser,
				   CBrowserImpl *mpBrowserImpl);

	nsCOMPtr<nsIWebBrowser> qaWebBrowser;
	CBrowserImpl	*qaBrowserImpl;
	nsIWebProgress * GetWebProgObject();
	void AddWebProgLstnr(PRUint32, PRInt16);
	void RemoveWebProgLstnr(PRInt16);
	void GetTheDOMWindow(PRInt16);
	void GetIsLoadingDocTest(PRInt16);

	void ConvertWPFlagToString(PRUint32, nsCAutoString&);
	void StoreWebProgFlag(PRUint32);
	void RetrieveWebProgFlag(void);

	void OnStartTests(UINT nMenuID);
	void RunAllTests(void);

	PRUint32 theStoredFlag;

public:
// Attributes

// Operations
public:


// Implementation
public:
	virtual ~CnsiWebProg();

	// Generated message map functions
protected:

private:
	nsCOMPtr<nsIWebProgress> qaWebProgress;

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NSIWEBPROG_H__8024AB8F_6DB3_11D6_9BA5_00C04FA02BE6__INCLUDED_)
